"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Action(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "source",
        "variantActionable",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "actionType": reports_4_2_0.ActionType,
            "status": reports_4_2_0.ActionStatus,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.ActionType": reports_4_2_0.ActionType,
            "org.gel.models.report.avro.ActionStatus": reports_4_2_0.ActionStatus,
            "org.gel.models.report.avro.Action": reports_4_2_0.Action,
        }

    __slots__ = [
        "source",
        "variantActionable",
        "actionType",
        "comments",
        "drug",
        "evidenceType",
        "evidences",
        "status",
        "url",
    ]

    def __init__(
        self,
        source,
        variantActionable,
        actionType=None,
        comments=None,
        drug=None,
        evidenceType=None,
        evidences=None,
        status=None,
        url=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.Action model.

        :param source:
            source of the information
        :type source: str
        :param variantActionable:
            Is variant level actionable
        :type variantActionable: boolean
        :param actionType:
        :type actionType: None | ActionType
        :param comments:
            comments
        :type comments: None | list[str]
        :param drug:
            drug
        :type drug: None | str
        :param evidenceType:
            type of evidence
        :type evidenceType: None | str
        :param evidences:
            array of PMIDs
        :type evidences: None | list[str]
        :param status:
            status i.e. clinical, pre-clinical
        :type status: None | ActionStatus
        :param url:
            link to original source
        :type url: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
